/*
    beep

    Wird kein Parameter bergeben, Piept beep einmal. Wird irgendein
    Parameter bergeben, so Piept und lt das Terminal blinken,
    solange bis mit C-c (Strl-C) besttigt wird.

    Copyright (c) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <curses.h>
#include <signal.h>
#include <stdio.h>
#include "hofmeier.h"
#include <stdlib.h>
#include <unistd.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>



char blacky_ver_info[] = "Blacky's Beep v0.04 (c) Copyright 1998,2003 Andreas Hofmeier";
int invert = 0, i, i2;
char *msg = NULL;
int msglen = 0;
char flashing = 1;

static void finish(int sig);


display()
{
  if (invert == 0) {
    attrset(A_STANDOUT);
    invert = 1;
  } else {
    attrset(A_NORMAL);
    invert = 0;
  }
  for (i = 0; i < LINES; i++) {
    gotoxy(1, i + 1);
    for (i2 = COLS; i2 > 0; i2--) {
      addstr(" ");
    }
  }
  gotoxy(COLS/2 - 13, LINES/2);
  addstr("Press any key to continue!");
  if (msg != NULL) {
    gotoxy(COLS/2 - msglen/2, LINES/2+1);
    addstr(msg);
  }
  refresh();
}


main(argc, argv)
  int argc;
  char *argv[];
{
  // select()
  fd_set rfds;
  struct timeval tv;
  int retval;

  if ((argc > 1) ? ((argv[1][0] == '-') && ((argv[1][1] == '?') || (toupper(argv[1][1]) == 'H'))) : 0) {
    printf("Help:\n");
    printf("  beep [-?] [-f] [msg]\n");
    printf("    -?   : Hilfe\n");
    printf("    -f   : don't flashing\n");
    printf("    [msg]: display message msg and wait belling and flashing for confirmation..\n");
    printf("    -v   : Version, Licenze\n");
    exit(0);
  }

  if ((argc == 2) ? ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'V')) : 0) {
    printf("%s\n\n", blacky_ver_info);
    printkinfo(stdout);
    exit(0);
  }

  if (argc == 1) {
    putchar(7);
    fflush(stdout);
  } else {
    if (strcmp(argv[1], "-f") != NULL) {
      msg = argv[1];
    } else {
      flashing = 0;
      msg = argv[2];
    }
    msglen = strlen(msg);

    if (flashing) {
      init_cur_graph();
    }
    signal(SIGINT, finish);      /* arrange interrupts to terminate */
    signal(SIGKILL, finish);
    signal(SIGTERM, finish);

    if (!flashing) {
      puts("Press any key to continue!");
      if (msg != NULL) {
	puts(msg);
      }
      system("/bin/stty cbreak");
    }
    while (1) {
      if (flashing) {
	display();
      }
      putchar(7);
      fflush(stdout);
      
      FD_ZERO(&rfds);
      FD_SET(0, &rfds);
      tv.tv_sec = 1;
      tv.tv_usec = 0;
      retval = select(1, &rfds, NULL, NULL, &tv);
      if (retval) {
	break;
      }
    }
    finish(0);
  }
}

static void finish(int sig)
{
  endwin();
  system("/bin/stty -cbreak");
  exit(0);
}
